(function($, Drupal) {

  Drupal.behaviors.verticalHoverMenu = {
    attach: function(context, settings) {
      /* 'Global' Vars */
      var timeoutShow = null;
      var timeoutHide = null;
      var timeoutClearStyles = null;
      var isMobile = null;
      var menuWidth = $('#toolbar-item-administration-tray').css('width');

      function checkMobile() {
        var isMobile = window.matchMedia("only screen and (max-width: 760px)");
        return isMobile.matches ? true : false
      };
      isMobile = checkMobile();

      $(window).resize(function() {
        isMobile = checkMobile();
      }.bind(isMobile));

      function clearStyles() {
        var child_menu = $(' ul.toolbar-menu', this);
        $('ul.toolbar-menu li.menu-item').each(function(i) {
          $(this).parent().attr('style', '');
          $(this).attr('style', '');
          $(this).find('button.toolbar-icon').removeClass('open');
        });
      }
      function clearClasses() {
        var child_menu = $(' ul.toolbar-menu', this);
        $('ul.toolbar-menu li.menu-item').each(function(i) {
          $(this).removeClass('menu-item--active-trail');
          $(this).removeClass('open');

        });
      }

      function delayedHoverShow() {
        clearClasses();
        clearTimeout(timeoutHide);

        var child_menu = $('> ul.toolbar-menu', this);

        child_menu.css('display', 'block');
        child_menu.css('position', 'relative');
        child_menu.css('margin-left', menuWidth);
        child_menu.css('margin-top', '-40px');
        child_menu.css('width', menuWidth);
        child_menu.css('height', 'inherit');

        $(this).css('height', '40px');

        $(this).siblings().find('ul.toolbar-menu').css('display', 'none');

        $('li.menu-item', child_menu).css('display', 'none');
        child_menu.children().css('display', 'block');

        $('> div.toolbar-box button.toolbar-icon', this).addClass('open');

      }

      function removeButtonStyle() {
        $('> div.toolbar-box button.toolbar-icon', this).removeClass('open');
      }

      // Main
      $('nav[role="navigation"] li.menu-item.menu-item--expanded').once("attachToolbarHoverEvents").each(function(item) {
        clearClasses();

        $(this).on('mouseenter', function(event) {
          clearTimeout(timeoutClearStyles);

          if ($('#toolbar-item-administration-tray > nav > div.toolbar-toggle-orientation > div > button').val() === 'horizontal' && !isMobile) {
            clearTimeout(timeoutShow);
            event.stopPropagation();
            timeoutShow = setTimeout(delayedHoverShow.bind(this), 250);
          }
          else {
            clearStyles();
          }
        }.bind(this));

        $(this).on('mouseleave', function(event) {
          if ($('#toolbar-item-administration-tray > nav > div.toolbar-toggle-orientation > div > button').val() === 'horizontal' && !isMobile) {
            clearTimeout(timeoutClearStyles);
            clearTimeout(timeoutHide);
            timeoutHide = setTimeout(removeButtonStyle.bind(this), 250);
            timeoutClearStyles = setTimeout(clearStyles, 1000);
          }
          else {
            clearStyles();
          }
        });
      });

      // When the orientation button is clicked
      $('#toolbar-item-administration-tray > nav > div.toolbar-toggle-orientation > div > button').on('click', function(e) {
        clearStyles();

      });

      $('button.toolbar-icon').hover(function(e) {
        clearTimeout(timeoutHide);
        clearTimeout(timeoutClearStyles);
      });
    }
  };
})(jQuery, Drupal);